#include <iostream>
#include <vector>

#include "seqinfileenumerator.hpp"
#include "intervalenumerator.hpp"
#include "linsearch.hpp"
#include "summation.hpp"
#include "intervalenumerator.hpp"

using namespace std;

class Copy : public Summation<int, vector<int> >
{
    int  func(const int &e) const override { return e; }
};

class InnerSearch : public LinSearch<int>
{
private:
    vector<int> _x;
    int _i;
public:
    InnerSearch(vector<int> x, int i) : _x(x), _i(i) {}
    bool cond(const int &j) const override { return _x[_i] == _x[j]; }
};

class OuterSearch : public LinSearch<int>
{
private:
    vector<int> _x;
public:
    OuterSearch(vector<int> x) : _x(x) {}
    bool cond(const int &i) const override
    {
        InnerSearch pr(_x, i);
        IntervalEnumerator enor(0, i-1);
        pr.addEnumerator(&enor);
        pr.run();
        return pr.found();
    }
};

int main()
{
    // Tmb feltltse szveges llomnybl
    vector<int> x;
    Copy pr1;
    SeqInFileEnumerator<int> enor1("input.txt");
    pr1.addEnumerator(&enor1);
    pr1.run();
    x = pr1.result();

    // Tmb els olyan elemnek keresse, amely azt megelzen mr szerepelt a tmbben
    OuterSearch pr2(x);
    IntervalEnumerator enor2(1, x.size()-1);
    pr2.addEnumerator(&enor2);
    pr2.run();

    if(pr2.found())
        cout << "A(z) " << x[pr2.elem()] << " ismetlodott eloszor.\n";
    else
        cout << "Csupa kulonbozo elem.\n";
    return 0;
}
